 Rem	*********************************************************************
Rem	The Encryption Wizard For Oracle
Rem	Version 8
Rem
Rem	Copyright - Relational Database Consultants, Inc.  
Rem	
Rem	Refer To: License_Agreement.txt
Rem
Rem	rdc_encrypt_install.sql
Rem
Rem	Installation script - to be run from SQL*Plus.
Rem	*********************************************************************
Rem
Rem	Note: 
Rem
Rem	If you are not using SQL*Net on your server, you will need to remove 
Rem 	the string "@&ServiceName", located at the end of the two "connect" 
Rem 	commands within this script. 
Rem
Rem	*********************************************************************

Set Echo Off
Set linesize 80

Undefine WizardPassword
Undefine SystemPassword
Undefine ServiceName
Undefine WizardTablespace
Undefine WizardTempSpace

Prompt Welcome to the Encryption Wizard Installation.  
Prompt This installation script will delete the Encryption Wizard account and then rebuild it.
Prompt If you would like to quit this script now, Hit <Ctrl>-C.
Prompt You will be asked for the current SYSTEM password
Prompt The value of this password will not be stored and will be Undefined immediately.
Prompt 
Prompt

Prompt Enter the password for the Oracle user account SYSTEM:
Accept SystemPassword

Prompt Enter the SQL*Net service_name used to connect to this database:
Accept ServiceName

Prompt Enter a password for the new Encryption Wizard account RDC_ENCRYPT_USER:
Accept WizardPassword

Prompt Enter the default tablespace for the Encryption Wizard user (optional):
Accept WizardTablespace

Prompt Enter the default temp tablespace for the Encryption Wizard user (optional):
Accept WizardTempSpace

Connect System/&SystemPassword@&ServiceName

Undefine SystemPassword

Spool rdc_encrypt_install.log

Prompt (following line: Oracle12c and above only)

Alter Session Set "_ORACLE_SCRIPT"=true; 

Prompt Dropping any previously created account...

Drop User RDC_Encrypt_User Cascade
/

Prompt Creating Encryption Wizard User account...

Create User RDC_Encrypt_User Identified by &&WizardPassword
/

Alter User RDC_Encrypt_User Default Tablespace &WizardTablespace
/

Alter User RDC_Encrypt_User Temporary Tablespace &WizardTempSpace
/

Grant 
Connect, 
Resource,
Execute_Catalog_Role,
Select_Catalog_Role,
Create Any Table,
Select Any Table,
Insert Any Table,
Update Any Table,
Delete Any Table,
Alter Any Table,
Lock Any Table,
Create Any Trigger,
Alter Any Trigger,
Drop Any Trigger,
Create Any View,
Create Any Index,
Global Query Rewrite,
Analyze Any,
Drop Any Index,
Drop Any View,
Create Public Synonym,
Drop Public Synonym
To RDC_Encrypt_User
/

Grant 
Select Any Dictionary
To RDC_Encrypt_User
/

Grant 
Grant Any Object Privilege 
To RDC_Encrypt_User
/


/* Must be set for Oracle 12c */
Grant 
Unlimited Tablespace 
To RDC_Encrypt_User
/

Connect RDC_Encrypt_User/&&WizardPassword@&ServiceName

Undefine ServiceName
Undefine WizardTablespace
Undefine WizardTempSpace

Set Echo 				On
Set Timing 				On
Set ServerOutput		On

Prompt Creating Encryption Wizard Schema...

Start rdc_encrypt_tables.sql

Start encrypted_tab_columns.view

Set Echo Off

Alter Session Set PLSQL_Optimize_Level=2;

Prompt Compiling Encryption Wizard Package Headers...

Start rdc_encrypt_headers.sql

Grant Execute On RDC_Encrypt_Runtime To Public;

Start valid_tab_columns.view
Start encrypted_tab_backup.view

Start rdc_encrypt_compile.sql

Start rdc_encrypt_aes.plb
Sho Err

Start rdc_encrypt_hsm_stub.plb
sho err

Exec RDC_Encrypt_Object.Setlicense;

Set Timing Off

Select
Decode(Count(*), 1, 'Encryption Wizard server installation successful...', 
'Installation failed.  Check rdc_encrypt_install.log for errors.') Installation_Status
From RDC_Encrypt_License;

Prompt AES Encryption Installation(Optional)
Prompt 
Prompt To enable Oracle DBMS_CRYPTO and AES256 Encryption,
Prompt issue this SQL grant as user SYS and hit return when finished: 
Prompt
Prompt "Grant Execute on DBMS_Crypto to RDC_Encrypt_User"

Pause

Col InstallAES format a70 Heading 'AES Installation Status'

Select
RDC_Encrypt_Util.InstallAES  InstallAES
From Dual;

Col Encryption_Type format a40 Heading 'Valid Encryption Types|Now Installed:'

Select
Encryption_Type 
From 
Valid_Encryption_Types;

Sho User

Spool Off

