Rem	*********************************************************************
Rem	The Encryption Wizard Version 7
Rem
Rem	Copyright 2002 - 2010 - Relational Database Consultants, Inc.  
Rem	
Rem	Refer To: License_Agreement.txt
Rem
Rem	rdc_hsm_install.sql
Rem
Rem	HSM Installation script - to be run from SQL*Plus as SYS.
Rem	*********************************************************************

Set ServerOutput On
Set Veri off
Set show off

Spool rdc_hsm_install.lst

Prompt This script must be run from SYS as SYSDBA, because only SYS can load HSM libraries into Oracle.
Prompt Make sure you have loaded LunaJCASP.jar, LunaJCESP.jar, ibmpkcs.jar, JavaHSM.jar 
Prompt with Oracle's loadjava utility Before running this script.
Prompt Output of this script will be sent to rdc_hsm_install.lst.
Prompt Hit Ctrl-C to terminate the HSM installation. Return to continue.

Pause

Create or Replace
Function SYS.RDC$InitMasterKey
(
	CardType	In 	Varchar2,
	Password	In 	Varchar2,
	KeyName			In Varchar2,
	SlotNum			In Number,
	EncryptionType	In Varchar2,
	KeyLength		In Number			
)
Return Varchar2
As Language Java Name
'RDC$JavaHSM.InitMasterKey( java.lang.String, java.lang.String, java.lang.String, int, java.lang.String, int) return java.lang.String';  
/

Sho Err

Create or Replace
Function SYS.RDC$ObfuscateSeed
(
	CardType		In Varchar2,
	Password		In Varchar2,
	KeyName		In Varchar2,
	SlotNum		In Number,
	Seed			In Raw
)
Return Raw
As Language Java Name
'RDC$JavaHSM.ObfuscateSeed( java.lang.String, java.lang.String, java.lang.String, int, byte[] ) return byte[]';  
/

Sho Err

Create or Replace
Function SYS.RDC$GetJavaParameter
(
	Name		In Varchar2
)
Return String
As Language Java Name
'RDC$JavaHSM.GetJavaParameter(java.lang.String) return java.lang.String';   
/

Prompt Any HSM API Libraries must be found in one of these paths:
Prompt

exec dbms_output.put_line(RDC$GetJavaParameter('java.library.path'));

Prompt Hit Return when you have comfirmed placement of HSM API Libraries.
Pause


Sho Err

Grant Execute on RDC$GetJavaParameter 	to RDC_Encrypt_User;
Grant Execute on RDC$InitMasterKey 		to RDC_Encrypt_User;
Grant Execute on RDC$ObfuscateSeed 		to RDC_Encrypt_User;

Prompt Make sure the Encryption Wizard has decrypted all encrypted data in your database.
Prompt This phase of the installation will reset your license to the new HSM Master Key.
Prompt You will need to enter your demo license again after this process completes.
Prompt You may run this script again later and repeat the above steps.
Prompt Hit Ctrl-C to terminate the HSM installation. Return to continue.
Pause

Prompt Enter the SQL*Net service_name used to connect to this database:
Accept ServiceName

Prompt Enter the password for the Encryption Wizard account RDC_ENCRYPT_USER:
Accept WizardPassword

Connect RDC_Encrypt_User/&WizardPassword@&ServiceName

exec dbms_java.set_output(10000000);

@rdc_encrypt_hsm.plb

Sho Err

Prompt Enter the exact name of the HSM Card Type (For example: Luna PCI 7000)
Accept CardType

Prompt Enter the Password you assigned for the HSM Key Store
Accept HSMPassword

Prompt Enter the Name of the Master Key you would like to assign for the Encryption Wizard
Accept MasterKeyName

Prompt Optionally Enter a Slot Number for the HSM card or hit return. It will be searched for otherwise.
Accept SlotNumber

exec RDC_Encrypt_HSM.Initialize('&CardType','&HSMPassword','&MasterKeyName', '&SlotNumber');

Col Name format a30 trunc
Col Value format a30 trunc
TTitle 'HSM Parameters Successfully Installed:' Skip 2

Select 
Name, 
RDC_Encrypt_HSM.GetParameter(Name, '&HSMPassword') Value
From HSM_parameters
Where Name Not In ('Class Hash', 'Password');


exec rdc_encrypt_object.setlicense;

Spool OFF
 
Prompt Encryption Wizard License Reset. You must register again as a demo user.
Prompt Enter your demo license code now or hit CTRL-C to register from the Java Interface later.
Accept DemoLicenseCode

exec rdc_encrypt_object.checkemailaddress('&DemoLicenseCode');

Sho user
